;(function(){

	window._w.holidays = {

		ti : null,
		itemId : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.holidays.ti = _t[template];

			_w.holidays.initGrid();

			// Holiday grid
			if (null == App.API.taskContract('gridHoliday'))
			{
				App.API.getTask(
						'gridHoliday', 'Auction', 'PublicHoliday.List', null,
						{}, _w.holidays.loadHolidayGrid, _w.taskContractError
						);
			}
			else
			{
				_w.holidays.loadHolidayGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addHoliday'))
			{
				App.API.getTask(
						'addHoliday', 'Auction', 'PublicHoliday.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.holidays.ti.hydrateParam('name', {
				type  : 'input',
				id    : 'name',
				title : 'Name',
				value : ''
			});
			_w.holidays.ti.hydrateParam('holiday', {
				type  : 'date',
				id    : 'holiday',
				title : 'Date',
				value : ''
			});
			_w.holidays._setupValidation();
			$('#btnNew').click(function() {
				_w.holidays.itemId = null;
				$('#name').val('');
				$('#holiday').val('');
				$('#btnSave').html(' Add ');
			});
		},

		initGrid : function()
		{

			_w.holidays.ti.hydrate({
				// Holiday grid
				'gridHolidayTitle': 'Manage holidays',
				'gridHolidayColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Name: {
							id: 'gridHolidayColumn_Name',
							title: 'NAME'
						},
						Holiday: {
							id: 'gridHolidayColumn_Holiday',
							title: 'HOLIDAY'
						}
					}
				},
				'gridHolidayRowRepeater': {}
			});

		},

		loadHolidayGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridHoliday', data, options,
					_w.holidays._onHolidayGridDataReceived, _w.taskExecError
					);
		},

		_onHolidayGridDataReceived : function( response )
		{
			_w.holidays.ti.hydrateParam('gridHolidayRowRepeater', {});
			var gridData = [];
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				gridData.push({
					prepend: {
						Amount  : 'R '
					},
					rowId : row.id,
					onClick : function(meta) {
						_w.holidays.itemId = meta.rowId;
						$('#name').val(meta.items.Name);
						$('#holiday').val(meta.items.Holiday);
						$('#btnSave').html(' Update ');
					},
					items: {
						'id'      : row.id,
						'Name'    : row.name ? row.name : '',
						'Holiday' : row.holiday ? row.holiday : ''
					}
				});
			}
			_w.holidays.ti.hydrateParam('gridHolidayRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		_setupValidation : function ()
		{
			$('#frmHolidayView').validate({
				"rules": {
					name: "required",
					holiday: {required: true, dateISO: true}
				},
				messages: {
					name : "This field is required.",
					holiday : {
						dateISO: "Must be a valid date."
					}
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var data = {
							PublicHoliday: {
								name: $('#name').val(),
								holiday: $('#holiday').val()
							}
					};
					if (null == _w.holidays.itemId)
					{
						App.API.execTask(
								'addHoliday', data, {},
								function() {
									$('#name').val('');
									$('#holiday').val('');
									_w.holidays.loadHolidayGrid( null, {}, {} );
									$('#btnSave').prop('disabled', false);
									$('#btnSave').html(' Add ');
								}, _w.taskExecError
							);
					}
					else
					{
						App.API.getTask(
								'updateHoliday' + _w.holidays.itemId, 'Auction', 'PublicHoliday.Update', null,
								{id: _w.holidays.itemId}, function () {
									App.API.execTask(
											'updateHoliday' + _w.holidays.itemId, data, {},
											function() {
												$('#name').val('');
												$('#holiday').val('');
												_w.holidays.loadHolidayGrid( null, {}, {} );
												$('#btnSave').prop('disabled', false);
												$('#btnSave').html(' Add ');
											}, _w.taskExecError
										);
								}, _w.taskContractError
								);
					}
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();