;(function(){

	window._w.newsletters = {

		itemId        : null,
		itemData      : null,
		formMeta      : null,
		ti            : null,
		newItem       : false,

		onTemplateReady : function( template, event, eventData )
		{
			_w.newsletters.ti = _t[template];

			_w.newsletters.initGrids();

			// Newsletter grid
			if (null == App.API.taskContract('gridSystemNewsletter'))
			{
				App.API.getTask(
						'gridSystemNewsletter', 'Newsletter', 'Newsletter.Grid', null,
						{}, _w.newsletters.loadNewsletterGrid, _w.taskContractError
						);
			}
			else
			{
				_w.newsletters.loadNewsletterGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			$(".gridNewsletterFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnNewsletterSearch').click();
				}
			});

			_w.newsletters.ti = _t[template];

			// Newsletter grid
			$('#btnNewsletterAdd').click(function() {
				window.location.hash = '/newsletterview?id=0';
			});
            $('#btnNewsletterClearSearch').click(_w.newsletters.clearNewsletterGridContext);
            $('#btnNewsletterSearch').click(_w.newsletters.searchNewsletterGrid);

		},

		initGrids : function()
		{

			_w.newsletters.ti.hydrate({
				// Newsletter grid
				'gridNewsletterTitle': 'Manage newsletters',
				'gridNewsletterColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Subject: {
							id: 'gridNewsletterColumn_Subject',
							title: 'SUBJECT',
							orderAsc: {
								id: 'gridNewsletterOrder_SubjectAsc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.subject', 'ASC')
							},
							orderDesc: {
								id: 'gridNewsletterOrder_SubjectDesc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.subject', 'DESC')
							}
						},
						Created: {
							id: 'gridNewsletterColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridNewsletterOrder_CreatedAsc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.created', 'ASC')
							},
							orderDesc: {
								id: 'gridNewsletterOrder_CreatedDesc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.created', 'DESC')
							}
						},
						SentTo: {
							id: 'gridNewsletterColumn_SentTo',
							title: 'SENT TO',
							orderAsc: {
								id: 'gridNewsletterOrder_SentToAsc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.sentTo', 'ASC')
							},
							orderDesc: {
								id: 'gridNewsletterOrder_SentToDesc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.sentTo', 'DESC')
							}
						},
						Status: {
							id: 'gridNewsletterColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridNewsletterOrder_StatusAsc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridNewsletterOrder_StatusDesc',
								bind: $.proxy(_w.newsletters.orderNewsletterGrid, this, 'newsletter.jobState', 'DESC')
							}
						}
					}
				},
				'gridNewsletterColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Subject : {
							id: 'gridNewsletterFilter_Subject',
							context: 'gridNewsletterFilter'
						},
						Created: {
							id: 'gridNewsletterFilter_Created',
							context: 'gridNewsletterFilter'
						},
						SentTo: {
							id: 'gridNewsletterFilter_SentTo',
							context: 'gridNewsletterFilter'
						},
						Status: {
							id: 'gridNewsletterFilter_Status',
							context: 'gridNewsletterFilter'
						}
					}
				},
				'gridNewsletterRowRepeater': {},
				'gridNewsletterPager': {}
			});

		},

		loadNewsletterGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemNewsletter', data, options,
					_w.newsletters._onNewsletterGridDataReceived, _w.taskExecError
					);
		},

		pageNewsletterGrid : function( page )
		{
			_w.newsletters.loadNewsletterGrid( {}, {"Grid":{"Page":page}} );
		},

		clearNewsletterGridContext : function()
		{
			$('.gridNewsletterContext').val('');
			$('.gridNewsletterFilter').val('');
			_w.newsletters.searchNewsletterGrid();
		},

		searchNewsletterGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridNewsletterFilter_Subject', 'newsletter.subject');
			filter = _w.filterIfnotEmpty(filter, 'gridNewsletterFilter_Created', 'newsletter.created');
			filter = _w.filterIfnotEmpty(filter, 'gridNewsletterFilter_Status', 'newsletter.jobState');
			filter = _w.filterIfnotEmpty(filter, 'gridNewsletterFilter_SentTo', 'newsletter.sentTo');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.newsletters.loadNewsletterGrid( null, request, {} );
		},

		_onNewsletterGridDataReceived : function( response )
		{
			_w.newsletters.ti.hydrateParam('gridNewsletterRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'newsletter.subject'    : 'gridNewsletterFilter_Subject',
				'newsletter.created'    : 'gridNewsletterFilter_Created',
				'newsletter.jobState'   : 'gridNewsletterFilter_Status',
				'newsletter.sentTo'     : 'gridNewsletterFilter_SentTo'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'newsletterview',
					prepend: {},
					style: {},
					items: {
						'id'         : row.id,
						'Subject'    : row.subject,
						'Created'    : row.created,
						'SentTo'     : row.sentTo,
						'Status'     : row.jobState
				}
				});
			}
			_w.newsletters.ti.hydrateParam('gridNewsletterRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'newsletterPager';
			response.Data.Meta.bind = _w.newsletters.pageNewsletterGrid;
			_w.newsletters.ti.hydrateParam('gridNewsletterPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderNewsletterGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.newsletters.loadNewsletterGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();