;(function(){

	window._w.newsletterview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		newItem : false,

		onTemplateDestruct : function()
		{
			/*if (CKEDITOR && CKEDITOR.instances.content)
			{
				CKEDITOR.instances.content.destroy();
			}*/
			//$('#content').remove();
		},

		onTemplateReady : function( template, event, eventData )
		{
			_w.newsletterview.ti = _t[template];

			_w.newsletterview.setNewsletterViewFormMeta();
			_w.newsletterview.ti.hydrate(_w.newsletterview.formMeta);

			// Retrieve initial view data.
			_w.newsletterview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.newsletterview.itemId || null == _w.newsletterview.itemId)
			{
				_w.newsletterview.newItem = true;
				_w.newsletterview.itemData = {};
				App.API.getTask(
					'createNewsletter', 'Newsletter', 'Newsletter.Create',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				_w.newsletterview.newItem = false;
				App.API.getTask(
					'updateNewsletter:' + _w.newsletterview.itemId, 'Newsletter', 'Newsletter.Update', _w.newsletterview.itemId,
					{'id':_w.newsletterview.itemId}, $.proxy( _w.newsletterview._onNewsletterViewDataReceived, this ), _w.taskContractError
				);
			}

		},

		onTemplatePublished : function( template, event, eventData )
		{
			if (_w.newsletterview.newItem)
			{
				_w.newsletterview._setupValidation();
			}
			$('#btnDraft').click(function() {
				if (!$('#frmNewsletterView').valid())
				{
					return;
				}
				$('#btnDraft').prop('disabled', true);
				$('#btnTest').prop('disabled', true);
				$('#btnUpdate').prop('disabled', true);
				var data = _w.newsletterview._prepNewsletterUpdateData();
				var options = {SaveDraft: true};
				if (_w.newsletterview.newItem)
				{
					App.API.execTask(
							'createNewsletter', data, options,
							_w.newsletterview._onNewsletterUpdated, function() {}
						);
				}
				else
				{
					App.API.execTask(
							'updateNewsletter:' + _w.newsletterview.itemId, data, options,
							_w.newsletterview._onNewsletterUpdated, function() {}
						);
				}
			});
			$('#btnTest').click(function() {
				if (!$('#frmNewsletterView').valid())
				{
					return;
				}
				$('#btnDraft').prop('disabled', true);
				$('#btnTest').prop('disabled', true);
				$('#btnUpdate').prop('disabled', true);
				var data = _w.newsletterview._prepNewsletterUpdateData();
				var options = {TestDraft: true};
				if (_w.newsletterview.newItem)
				{
					App.API.execTask(
							'createNewsletter', data, options,
							_w.newsletterview._onNewsletterUpdated, _w.taskExecError
						);
				}
				else
				{
					App.API.execTask(
							'updateNewsletter:' + _w.newsletterview.itemId, data, options,
							_w.newsletterview._onNewsletterUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').click(function() {
				if (!$('#frmNewsletterView').valid())
				{
					return;
				}
				$('#btnDraft').prop('disabled', true);
				$('#btnTest').prop('disabled', true);
				$('#btnUpdate').prop('disabled', true);
				var data = _w.newsletterview._prepNewsletterUpdateData();
				var options = {Send: true};
				if (_w.newsletterview.newItem)
				{
					App.API.execTask(
							'createNewsletter', data, options,
							_w.newsletterview._onNewsletterUpdated, _w.taskExecError
						);
				}
				else
				{
					App.API.execTask(
							'updateNewsletter:' + _w.newsletterview.itemId, data, options,
							_w.newsletterview._onNewsletterUpdated, _w.taskExecError
						);
				}
			});
		},

		setNewsletterViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			console.log('------------------');
			console.log(data.attachment);
			_w.newsletterview.formMeta = {
				'attachment' : {
					type  : 'attachment',
					id    : 'attachment',
					title : 'Attachment',
					value : data.attachment ? data.attachment : null
				},
				'subject' : {
					type  : 'input',
					id    : 'subject',
					title : 'Subject',
					value : data.subject ? data.subject : '',
					maxlength : 100
				},
				'content' : {
					type  : 'htmltext',
					id    : 'content',
					title : 'Content',
					value : data.content ? data.content : ''
				}
			};
		},

		_onNewsletterViewDataReceived : function( response )
		{
			_w.newsletterview.itemId = response.Data.id;
			_w.newsletterview.itemData = response.Data;
			_w.newsletterview.setNewsletterViewFormMeta(response.Data);
			_w.newsletterview.ti.hydrate(_w.newsletterview.formMeta);
			if (!_w.newsletterview.newItem)
			{
				switch (response.Data.jobState)
				{
				case 'Sending':
				case 'Archived':
					$('#btnDraft').hide();
					$('#btnTest').hide();
					$('#btnUpdate').hide();
					break;
				}
			}
			_w.newsletterview._setupValidation();
		},

		_setupValidation : function ()
		{
			$('#frmNewsletterView').validate({
				"rules": {
					subject: "required",
					content: "required"
				},
				submitHandler: function( form ) {
					$('#btnDraft').prop('disabled', true);
					$('#btnTest').prop('disabled', true);
					$('#btnUpdate').prop('disabled', true);
					var data = _w.newsletterview._prepNewsletterUpdateData();
					if (_w.newsletterview.newItem)
					{
						App.API.execTask(
								'createNewsletter', data, {},
								_w.newsletterview._onNewsletterUpdated, _w.taskExecError
							);
					}
					else
					{
						App.API.execTask(
								'updateNewsletter:' + _w.newsletterview.itemId, data, {},
								_w.newsletterview._onNewsletterUpdated, _w.taskExecError
							);
					}
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepNewsletterUpdateData : function()
		{
			var data = {Newsletter:_w.newsletterview.ti.harvest()};
			if ('' == data.Newsletter.attachment)
			{
				data.Newsletter.attachment = null;
			}
			return data;
		},

		_onNewsletterUpdated : function( response )
		{
			window.location.hash = '/newsletters';
		}

	};

})();