;(function(){

	window._w.opendays = {

		ti : null,
		itemId : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.opendays.ti = _t[template];

			_w.opendays.initGrid();

			// Openday grid
			App.DataStore.loadSelectListData('groups', true, 'Company', 'Group.SelectList');
			App.DataStore.listen('openDayChecklistBuilder', 'group');
			if (null == App.API.taskContract('gridOpenday'))
			{
				App.API.getTask(
						'gridOpenday', 'Auction', 'OpenDay.List', null,
						{}, _w.opendays.loadOpendayGrid, _w.taskContractError
						);
			}
			else
			{
				_w.opendays.loadOpendayGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addOpenday'))
			{
				App.API.getTask(
						'addOpenday', 'Auction', 'OpenDay.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.opendays.ti.hydrateParam('openday', {
				type  : 'date',
				id    : 'openday',
				title : 'Date',
				value : '',
				dtopt : {
					daysOfWeekDisabled: [0,1,2,3,4,5]
				}
			});
			_w.opendays.ti.hydrateParam('allgroups', {
				type  		: 'checkbox',
				id    		: 'allgroups',
				title 		: '<b>Select all</b>',
				value 		: false,
				onChange 	: function() {
					$('.companyGroup').prop('checked', $(this).is(':checked'));
				}
			});
			_w.opendays.ti.hydrateParam('groups', {
				type  		: 'checkGroup',
				id    		: 'groups',
				dataStoreId : 'groups',
				itemName    : 'companyGroup',
				data 		: {}
			});
			_w.opendays._setupValidation();
			$('#btnNew').click(function() {
				_w.opendays.itemId = null;
				$('#openday').val('');
				$('#allgroups').prop('checked', false);
				$('.companyGroup').prop('checked', false);
				$('#btnSave').html(' Add ');
				$('#btnDelete').hide();
				$('#openday').attr('disabled', false);
			});
			$('#btnDelete').click(function() {
				App.API.getTask(
						'deleteOpenday' + _w.opendays.itemId, 'Auction', 'OpenDay.Delete', null,
						{id: _w.opendays.itemId}, function () {
							App.API.execTask(
									'deleteOpenday' + _w.opendays.itemId, {}, {},
									function() {
										$('#btnDelete').hide();
										$('#openday').val('');
										$('#allgroups').prop('checked', false);
										$('.companyGroup').prop('checked', false);
										_w.opendays.loadOpendayGrid( null, {}, {} );
										$('#btnSave').prop('disabled', false);
										$('#btnSave').html(' Add ');
										$('#openday').attr('disabled', false);
										_w.opendays.itemId = null;
									}, function(error) {
										alert(error.StatusReason);
									}
								);
						}, _w.taskContractError
					);
			});
		},

		initGrid : function()
		{

			_w.opendays.ti.hydrate({
				// Openday grid
				'gridOpendayTitle': 'Manage open auction days',
				'gridOpendayColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Openday: {
							id: 'gridOpendayColumn_Openday',
							title: 'OPEN DAY'
						}
					}
				},
				'gridOpendayRowRepeater': {}
			});

		},

		loadOpendayGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridOpenday', data, options,
					_w.opendays._onOpendayGridDataReceived, _w.taskExecError
					);
		},

		_onOpendayGridDataReceived : function( response )
		{
			_w.opendays.ti.hydrateParam('gridOpendayRowRepeater', {});
			var gridData = [];
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				gridData.push({
					prepend: {
						Amount  : 'R '
					},
					rowId : row.id,
					onClick : $.proxy(function(row, meta) {
						_w.opendays.itemId = meta.rowId;
						$('#openday').val(meta.items.Openday);
						$('#openday').attr('disabled', true);
						$('.companyGroup').prop('checked', false);
						for (var i in row.groups)
						{
							$('input[data-id="' + row.groups[i].id + '"]').prop('checked', true);
						}
						$('#btnSave').html(' Update ');
						$('#btnDelete').show();
					}, this, row),
					items: {
						'id'      : row.id,
						'Openday' : row.openDate ? row.openDate : ''
					}
				});
			}
			_w.opendays.ti.hydrateParam('gridOpendayRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		_setupValidation : function ()
		{
			$('#frmOpendayView').validate({
				"rules": {
					openday: {required: true, dateISO: true}
				},
				messages: {
					openday : {
						dateISO: "Must be a valid date."
					}
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var items = [];
					$.each($.find('.companyGroup'), function(i, input) {
						if ( $(input).prop('checked') )
						{
							items.push({
								'id': $(input).attr('data-id')
							});
						}
					});
					var data = {
							OpenDay: {
								openDate: $('#openday').val(),
								groups: items
							}
					};
					if (null == _w.opendays.itemId)
					{
						App.API.execTask(
								'addOpenday', data, {},
								function() {
									$('#btnDelete').hide();
									$('#openday').val('');
									$('#allgroups').prop('checked', false);
									$('.companyGroup').prop('checked', false);
									_w.opendays.loadOpendayGrid( null, {}, {} );
									$('#btnSave').prop('disabled', false);
									$('#btnSave').html(' Add ');
									$('#openday').attr('disabled', false);
									_w.opendays.itemId = null;
								}, _w.taskExecError
							);
					}
					else
					{
						App.API.getTask(
								'updateOpenday' + _w.opendays.itemId, 'Auction', 'OpenDay.Update', null,
								{id: _w.opendays.itemId}, function () {
									App.API.execTask(
											'updateOpenday' + _w.opendays.itemId, data, {},
											function() {
												$('#btnDelete').hide();
												$('#openday').val('');
												$('#allgroups').prop('checked', false);
												$('.companyGroup').prop('checked', false);
												_w.opendays.loadOpendayGrid( null, {}, {} );
												$('#btnSave').prop('disabled', false);
												$('#btnSave').html(' Add ');
												$('#openday').attr('disabled', false);
												_w.opendays.itemId = null;
											}, _w.taskExecError
										);
								}, _w.taskContractError
								);
					}
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();