;(function(){

	window._w.retailview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		newItem : false,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.retailview.ti = _t[template];
			_w.retailview.itemData = null;
			_w.retailview.itemId = App.Util.getUrlParam('id');
			_w.retailview.newItem = (0 == _w.retailview.itemId || null == _w.retailview.itemId)
				? true
				: false;
			App.DataStore.loadSelectListData('retailers', true, 'Retail', 'Retail.SelectList');
			_w.retailview.setRetailViewFormMeta();
			_w.retailview.ti.hydrate(_w.retailview.formMeta);

			// Retrieve initial view data.
			if (_w.retailview.newItem)
			{
				_w.retailview.itemData = {};
				App.API.getTask(
					'createRetail', 'Company', 'CompanyRetail.Create',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				App.API.getTask(
					'updateRetail:' + _w.retailview.itemId, 'Company', 'CompanyRetail.Update', null,
					{'id':_w.retailview.itemId}, _w.retailview._onRetailViewDataReceived, _w.taskContractError
				);
			}

		},

		onViewPublished : function( template, event, eventData )
		{
			$('#btnArchive').click(_w.retailview._routeToArchived);
			$('#btnActivate').click(_w.retailview._routeToActive);
			if (_w.retailview.newItem)
			{
				_w.retailview._setupValidation();
			}

			if (!_w.retailview.newItem && null != _w.retailview.itemData)
			{
				_w.retailview._onDataAndTemplate();
			}
		},

		_routeToActive : function()
		{
			if (!$('#frmRetailView').valid())
			{
				return;
			}
			var data = _w.retailview._prepRetailUpdateData();
			data.CompanyRetail.archived = false;
			App.API.execTask(
					'updateRetail:' + _w.retailview.itemId, data, {},
					_w.retailview._onRetailUpdated, _w.taskExecError
				);
		},

		_routeToArchived : function()
		{
			if (!$('#frmRetailView').valid())
			{
				return;
			}
			var data = _w.retailview._prepRetailUpdateData();
			data.CompanyRetail.archived = true;
			App.API.execTask(
					'updateRetail:' + _w.retailview.itemId, data, {},
					_w.retailview._onRetailUpdated, _w.taskExecError
				);
		},

		setRetailViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.retailview.formMeta = {
				'retail' : {
					type        : 'select',
					id          : 'retail',
					title       : 'Retailer',
					dataStoreId : 'retailers',
					value       : data.retail ? data.retail.id : '',
					disabled    : _w.retailview.newItem ? false : true
				},
				'username' : {
					type  : 'input',
					id    : 'username',
					title : 'Username',
					value : data.username ? data.username : '',
					maxlength : 150
				},
				'password' : {
					type  : 'input',
					id    : 'password',
					title : 'Password',
					value : data.password ? data.password : '',
					maxlength : 64
				}
			};
		},

		_onDataAndTemplate : function() {
			if (!_w.retailview.newItem)
			{
				if (_w.retailview.itemData.archived)
				{
					$('#btnActivate').show();
				}
				else
				{
					$('#btnArchive').show();
				}
			}
			_w.retailview._setupValidation();
		},

		_onRetailViewDataReceived : function( response )
		{
			_w.retailview.itemId = response.Data.id;
			_w.retailview.itemData = response.Data;
			_w.retailview.setRetailViewFormMeta(response.Data);
			_w.retailview.ti.hydrate(_w.retailview.formMeta);
			if (_w.retailview.ti.published)
			{
				_w.retailview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			$('#frmRetailView').validate({
				"rules": {
					retail: "required",
					username: {required: true, maxlength: 150},
					password: {required: true, maxlength: 64}
				},
				invalidHandler: function(event, validator) {
				    var errors = validator.numberOfInvalids();
				    if (0 < _w.valuationview.validations && errors) {
				      var message = errors == 1
				        ? 'You missed 1 field. It has been highlighted'
				        : 'You missed ' + errors + ' fields. They have been highlighted';
				      alert(message);
				    }
				    _w.valuationview.validations++;
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.retailview._prepRetailUpdateData();
					if (_w.retailview.newItem)
					{
						App.API.execTask(
								'createRetail', data, {},
								_w.retailview._onRetailUpdated, _w.taskExecError
							);
					}
					else
					{
						App.API.execTask(
								'updateRetail:' + _w.retailview.itemId, data, {},
								_w.retailview._onRetailUpdated, _w.taskExecError
							);
					}
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepRetailUpdateData : function()
		{
			var data = {CompanyRetail:_w.retailview.ti.harvest()};
			return data;
		},

		_onRetailUpdated : function( response )
		{
			window.location.hash = '/settings';
		}

	};

})();