;(function(){

	window._w.userview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		limited : false,
		newItem : false,
		ownAccount : false,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.userview.ti = _t[template];
			_w.userview.itemData = null;
			_w.userview.limited = ('limiteduserview' == template)
				? true
				: false;

			App.DataStore.loadSelectListData('permissions', true, 'User', 'Permissions.SelectList');
			App.DataStore.loadSelectListData('managers', true, 'User', 'Profile.ManagerList');



			_w.userview.setUserViewFormMeta();
			_w.userview.ti.hydrate(_w.userview.formMeta);

			// Retrieve initial view data.
			_w.userview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.userview.itemId || null == _w.userview.itemId)
			{
				_w.userview.newItem = true;
				_w.userview.ownAccount = false;
				_w.userview.itemData = {};
				App.API.getTask(
					'createUser', 'User', 'Profile.Create',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				_w.userview.ownAccount = (App.userData.id == _w.userview.itemId)
					? true
					: false;
				_w.userview.newItem = false;
				App.API.getTask(
					'updateUser:' + _w.userview.itemId, 'User', 'Profile.Update', _w.userview.itemId,
					{'id':_w.userview.itemId}, _w.userview._onUserViewDataReceived, _w.taskContractError
				);
			}

		},

		onViewPublished : function( template, event, eventData )
		{
			$('#btnResetPin').click(function() {
				App.API.getTask(
						'PinReset:' + _w.userview.itemId, 'User', 'Profile.ForgotPassword', null,
						{}, function () {
							App.API.execTask(
									'PinReset:' + _w.userview.itemId, {
										Reset : {
											email : _w.userview.itemData.email
										}
								}, {},
								function() {
									alert('Pin reset successfull.');
								}, _w.taskExecError
							);
						}, _w.taskContractError
				);
			});

			$('#btnChangePin').click(function() {
				window.location.hash = '/changepinview?id='+_w.userview.itemId;
			});


			$('#btnSuspend').click(_w.userview._routeToSuspended);
			$('#btnActivate').click(_w.userview._routeToActive);
			$('#btnArchive').click(_w.userview._routeToArchived);
			$('#btnUnarchive').click(_w.userview._routeToActive);
			if (_w.userview.newItem)
			{
				_w.userview._setupValidation();
			}

			if (!_w.userview.newItem && null != _w.userview.itemData)
			{
				_w.userview._onDataAndTemplate();
			}
		},

		_routeToActive : function()
		{
			App.API.directRoute(
				'routeUserActive:' + _w.userview.itemId, 'User', 'Workflow.MoveToActive',
				_w.userview.itemId, {}, _w.userview._onUserUpdated, _w.taskExecError
			);
		},

		_routeToSuspended : function()
		{
			App.API.directRoute(
				'routeUserSuspended:' + _w.userview.itemId, 'User', 'Workflow.MoveToSuspended',
				_w.userview.itemId, {}, _w.userview._onUserUpdated, _w.taskExecError
			);
		},

		_routeToArchived : function()
		{
			App.API.directRoute(
				'routeUserArchive:' + _w.userview.itemId, 'User', 'Workflow.MoveToArchive',
				_w.userview.itemId, {}, _w.userview._onUserUpdated, _w.taskExecError
			);
		},

		setUserViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			var defPrm = '';
			if ('Auction Buyer' == App.permissions.name)
			{
				defPrm = 12;
			}
			if ('Auction Buyer & Seller' == App.permissions.name)
			{
				defPrm = 13;
			}
			_w.userview.formMeta = {
				'firstName' : {
					type  : 'input',
					id    : 'firstName',
					title : 'Name',
					value : data.firstName ? data.firstName : '',
					maxlength : 100
				},
				'familyName' : {
					type  : 'input',
					id    : 'familyName',
					title : 'Surname',
					value : data.familyName ? data.familyName : '',
					maxlength : 100
				},
				'idNumber' : {
					type  : 'input',
					id    : 'idNumber',
					title : 'ID Number',
					value : data.idNumber ? data.idNumber : '',
					maxlength : 13,
					onChange  : function() {
						var dig = $(this).val().substring(0, 6);
						$('#dateOfBirth').val(
								'19' + dig.substring(0, 2) +
								'-' + dig.substring(2, 4) +
								'-' + dig.substring(4, 6)
								);
					}
				},
				'dateOfBirth' : {
					type  : 'input',
					id    : 'dateOfBirth',
					title : 'Date of birth',
					style : 'datepicker',
					value : data.dateOfBirth ? data.dateOfBirth : ''
				},
				'mobile' : {
					type  : 'mobile',
					id    : 'mobile',
					title : 'Mobile',
					value : data.mobile ? data.mobile : '',
					maxlength : 20
				},
				'email' : {
					type  : 'input',
					id    : 'email',
					title : 'Email',
					value : data.email ? data.email : '',
					maxlength : 255
				},
				'manager' : {
					type        : 'select',
					id          : 'manager',
					title       : 'Assign to',
					selectEmpty : 'Nobody',
					dataStoreId : 'managers',
					value       : data.manager ? data.manager : ''
				},
				'permissions' : {
					type        : 'select',
					id          : 'permissions',
					title       : 'User type',
					dataStoreId : 'permissions',
					value       : data.permissions
							? data.permissions
							: defPrm,
					disabled    : !App.permissions.settingsUser
								|| 'Auction Buyer' == App.permissions.name
								|| 'Auction Buyer & Seller' == App.permissions.name
				},

				'subscribeNewsletter' : {
					type  : 'checkbox',
					id    : 'subscribeNewsletter',
					title : 'Subscribe to newsletters',
					value : data.subscribeNewsletter ? data.subscribeNewsletter : false
				}
			};
		},

		_onDataAndTemplate : function() {
			if (!_w.userview.newItem)
			{
				switch (_w.userview.itemData.jobState)
				{
				case 'Active':
					true == App.permissions.settingsResetPin ? $('#btnResetPin').show() : $('#btnResetPin').hide();
					$('#btnSuspend').show();
					$('#btnArchive').show();
					break;
				case 'Suspended':
					$('#btnActivate').show();
					$('#btnArchive').show();
					break;
				case 'Archived':
					$('#btnUnarchive').show();
					break;
				}
			}
			_w.userview._setupValidation();
		},

		_onUserViewDataReceived : function( response )
		{
			if (App.companyData.id != response.Data.company)
			{
				return;
			}
			_w.userview.itemId = response.Data.id;
			_w.userview.itemData = response.Data;
			_w.userview.setUserViewFormMeta(response.Data);
			_w.userview.ti.hydrate(_w.userview.formMeta);
			if (_w.userview.ti.published)
			{
				_w.userview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			$('#frmUserView').validate({
				"rules": {
					firstName: "required",
					familyName: "required",
					idNumber: {required: true, minlength: 13, maxlength: 13, digits: true},
					dateOfBirth: {required: true, dateISO: true},
					mobile: {required: true, mobile: true},
					email: {
						required: true,
						email: true,
						remote: {
							url: "/workspace/validate-unique-field-direct",
							type: "post",
							data: {
								Workspace 	: 'User',
								Group 		: 'Profile',
								Label 		: 'Email',
								Field 		: 'email',
								Value 		: function() {
									return $("#email").val();
								},
								Id 			: $.proxy(function() {
									return _w.userview.itemId;
								}, this)
							}
						}
					},
					permissions: "required"
				},
				messages: {
					firstName : "This field is required.",
					familyName : "This field is required.",
					email: {
						email: "Must be a valid email address."
					},
					idNumber: {
						minlength: "Must be 13 digits.",
						maxlength: "Must be 13 digits."
					},
					dateOfBirth: {
						dateISO: "Must be a valid date."
					},
					permissions : "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.userview._prepUserUpdateData();
					if (_w.userview.newItem)
					{
						App.API.execTask(
								'createUser', data, {},
								_w.userview._onUserUpdated, _w.taskExecError
							);
					}
					else
					{
						App.API.execTask(
								'updateUser:' + _w.userview.itemId, data, {},
								_w.userview._onUserUpdated, _w.taskExecError
							);
					}
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepUserUpdateData : function()
		{
			var data = {Profile:_w.userview.ti.harvest()};
			if ('' == data.Profile.manager)
			{
				data.Profile.manager = null;
			}
			return data;
		},

		_onUserUpdated : function( response )
		{
			if (_w.userview.ownAccount)
			{
				App.API.getTask(
						'updateOffer:' + _w.offerview.offerId, 'User', 'Profile.ActiveAccount', null,
						{}, function (response) {
							App.permissions = response.Data.permissions;
							delete response.Data.permissions;
							App.companyData = response.Data.company;
							delete response.Data.company;
							App.userData = response.Data;
							window.location.hash = '/settings';
						}, _w.onActiveAccountFailure
					);
			}
			else
			{
				window.location.hash = '/settings';
			}
		}

	};

})();